package org.bitbucket.bradleysmithllc.etlunit.feature.database;

import org.bitbucket.bradleysmithllc.etlunit.feature.database.db.Database;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestValueObject;

import java.util.List;

public interface DatabaseConnection {
	String getId();

	Database getDatabase();
	boolean hasDatabase();

	boolean declaresModes();


	String getAdminUserName();
	String getAdminPassword();

	String getImplementationId();

	String getDatabaseName(String mode);

	String getLoginName(String mode);

	String getPassword(String mode);

	String getServerName();

	List<String> getSchemaScripts();

	ETLTestValueObject getDatabaseConfiguration();

	ETLTestValueObject getDatabaseProperties();

	void setDatabase(Database database);
}